 /**    
  ******************************************************************************
  * @attention    
  * Copyright 2023 SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICRO.)
  *        
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met: 
  *    
  * 1. Redistributions of source code must retain the above copyright notice, 
  *    this list of conditions and the following disclaimer.
  *    
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  *    
  * 3. Neither the name of the copyright holder nor the names of its contributors 
  *    may be used to endorse or promote products derived from this software without
  *    specific prior written permission.
  *    
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
  * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
  * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
  *******************************************************************************
  */
#ifndef __CLOCK_H__
#define __CLOCK_H__
#include "main.h"



/* ϵͳʱ */ 
typedef enum {
    SYSCLK_RCHF_8M,    
    SYSCLK_RCHF_16M,   
    SYSCLK_RCHF_24M,   
}SysClk;


typedef enum
{
    SYSCLK_NORMAL = 0x00000000,
    SYSCLK_ERROR  = 0x55AAAA55,
}SYSCLK_STATE;




/* RCHFʱӲ */
typedef struct{
    
    /* RCHFʱƵ */
    uint32_t Frequence;

}FL_RCHF_InitTypeDef;




/*XTHFʱӲ*/
typedef struct{
    
    /* XTHFƵ */
    uint32_t Frequence;
  
    /* XTHFǿ */
    uint32_t DriverStrength;

}FL_XTHF_InitTypeDef;




/*PLLʱӲ*/
typedef struct{
  
    /* PLLƵ */
    uint32_t Multiplier;
  
    /* PLLοʱԤƵ */
    uint32_t Prescaler;
  
    /* PLLʱԴѡ */
    uint32_t ClockSource;
  
}FL_PLL_InitTypeDef;






extern volatile uint32_t Period10msFlag;
extern volatile uint32_t SYSCLKSELErrorState;
extern volatile SYSCLK_STATE SYSCLKState;
extern const FL_RCHF_InitTypeDef RCHF_InitParameter;
extern const FL_XTHF_InitTypeDef XTHF_InitParameter;
extern const FL_PLL_InitTypeDef PLL_InitParameter;

extern uint32_t SelXTHFToPLL(const FL_XTHF_InitTypeDef *XTHFInitParameter ,const FL_PLL_InitTypeDef *PLLInitParameter);

extern void SwtichToSenondarySystemClock(const FL_RCHF_InitTypeDef *RCHFInitParameter,
                                         const FL_PLL_InitTypeDef  *PLLInitParameter);

extern void SwtichToMainSystemClock(const FL_RCHF_InitTypeDef *RCHFInitParameter,
                                    const FL_XTHF_InitTypeDef *XTHFInitParameter,
                                    const FL_PLL_InitTypeDef  *PLLInitParameter);

extern void FoutInit(void);

#endif

