 /**    
  ******************************************************************************
  * @attention    
  * Copyright 2023 SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICRO.)
  *        
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met: 
  *    
  * 1. Redistributions of source code must retain the above copyright notice, 
  *    this list of conditions and the following disclaimer.
  *    
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  *    
  * 3. Neither the name of the copyright holder nor the names of its contributors 
  *    may be used to endorse or promote products derived from this software without
  *    specific prior written permission.
  *    
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
  * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
  * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
  *******************************************************************************
  */
#ifndef __GPTIM_H__
#define __GPTIM_H__
#include "main.h"


extern void GPTIM0_Init(void);
extern void GPTIM0_IC_Init(void);
extern void GPTIM0_Loop(void);
extern void GPTIM1_PWM_Init(void);
extern void GPTIM0_DeInit(void);
extern void GPTIM1_DeInit(void);

extern void clear_pwm_update_flag(void);
extern uint8_t get_pwm_status(uint32_t *frequency, uint8_t *duty);
extern void SET_PWM_Para(uint32_t frequency, uint8_t duty);

#if (SLEEP_SUPPORT == 1)
extern void GPTIM0_Sleep_Init(void);
extern void GPTIM0_Awake_Init(uint8_t awake_type);
extern uint8_t GPTIM0_IS_Sleep(void);

extern void GPTIM1_Sleep_Init(void);
extern void GPTIM1_Awake_Init(uint8_t awake_type);
extern uint8_t GPTIM1_IS_Sleep(void);
#endif

#endif
