 /**    
  ******************************************************************************
  * @attention    
  * Copyright 2023 SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICRO.)
  *        
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met: 
  *    
  * 1. Redistributions of source code must retain the above copyright notice, 
  *    this list of conditions and the following disclaimer.
  *    
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  *    
  * 3. Neither the name of the copyright holder nor the names of its contributors 
  *    may be used to endorse or promote products derived from this software without
  *    specific prior written permission.
  *    
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
  * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
  * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
  *******************************************************************************
  */
#ifndef  _LED_H_
#define  _LED_H_

#include "main.h"

#define LED_TOG_MODE   1 /*1:GPIO ת  0GPTIM1 PWM */

/* BLUE */
#define LED1_GPIO   GPIOC
#define LED1_PIN    FL_GPIO_PIN_0

/* RED */
#define LED2_GPIO   GPIOC
#define LED2_PIN    FL_GPIO_PIN_1

/* GREEN */
#define LED3_GPIO   GPIOA
#define LED3_PIN    FL_GPIO_PIN_4


#define LED1_ON()   FL_GPIO_ResetOutputPin(LED1_GPIO, LED1_PIN)
#define LED1_OFF()  FL_GPIO_SetOutputPin(LED1_GPIO, LED1_PIN)
#define LED1_TOG()  FL_GPIO_ToggleOutputPin(LED1_GPIO, LED1_PIN)

#define LED2_ON()   FL_GPIO_ResetOutputPin(LED2_GPIO, LED2_PIN)
#define LED2_OFF()  FL_GPIO_SetOutputPin(LED2_GPIO, LED2_PIN)
#define LED2_TOG()  FL_GPIO_ToggleOutputPin(LED2_GPIO, LED2_PIN)

#define LED3_ON()   FL_GPIO_ResetOutputPin(LED3_GPIO, LED3_PIN)
#define LED3_OFF()  FL_GPIO_SetOutputPin(LED3_GPIO, LED3_PIN)
#define LED3_TOG()  FL_GPIO_ToggleOutputPin(LED3_GPIO, LED3_PIN)

#if LED_TOG_MODE

void LED_Iint(void);
void LED_AWAKE_TEST(void);
void LED_KEY_TEST(void);
void LED_ENTER_SLEEP_TEST(void);
void LED_RUN_TEST(void);
void LED_IIC_TEST(void);
void LED_SPI_TEST(void);
void LED_USER_FLASH_TEST(void);
void LED_TEST_TEST(void);

#endif


#if (SLEEP_SUPPORT == 1)

void LED_Sleep_Init(void);
void LED_Awake_Init(uint8_t awake_type);
uint8_t LED_IS_Sleep(void);

#endif

#endif
