/**    
  ******************************************************************************
  * @attention    
  * Copyright 2023 SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICRO.)
  *        
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met: 
  *    
  * 1. Redistributions of source code must retain the above copyright notice, 
  *    this list of conditions and the following disclaimer.
  *    
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  *    
  * 3. Neither the name of the copyright holder nor the names of its contributors 
  *    may be used to endorse or promote products derived from this software without
  *    specific prior written permission.
  *    
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
  * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
  * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
  *******************************************************************************
  */
#include "key.h"
#include "led.h"


/**
  * @brief  Key ųʼ
  * @param  void
  * @retval void
  */
void KEY_Init(void)
{
    FL_GPIO_InitTypeDef GPIO_InitStruct = {0};
    
    /* KeyţΪ빦 */
    GPIO_InitStruct.pin           = KEY_PIN;
    GPIO_InitStruct.mode          = FL_GPIO_MODE_INPUT;
    GPIO_InitStruct.outputType    = FL_GPIO_OUTPUT_PUSHPULL;
    GPIO_InitStruct.pull          = FL_ENABLE;
    GPIO_InitStruct.remapPin      = FL_DISABLE;
    
    (void)FL_GPIO_Init(KEY_GPIO, &GPIO_InitStruct);
}


/**
  * @brief  Key ¼
  * @param  void
  * @retval void
  */
void KEY_Process(void)
{
    if (KEY_N)
    {
        FL_DelayMs(100);    /* ʱȥ */
        if (KEY_N)
        {
            /* û */
            LED_KEY_TEST();
        }
        while (KEY_N);      /* ȴͷ */
    }    
}

#if (SLEEP_SUPPORT == 1)

/**
  * @brief  Key ǰʼ
  * @param  void
  * @retval void
  */
void KEY_Sleep_Init(void)
{
    FL_EXTI_InitTypeDef extiInitStruct = {0};
    FL_EXTI_CommonInitTypeDef extiCommonInitStruct = {0};    
    
    /* رշǻ */
    
    /* رշǻIO */
    
    /* Դ */
    /* ʹⲿжϲ */
    FL_RCC_EnableEXTIOnSleep();
    FL_RCC_EnableGroup1OperationClock(FL_RCC_GROUP1_OPCLK_EXTI);/* EXTIʱʹ */

    /* EXTIжϲʱѡ */
    extiCommonInitStruct.clockSource = FL_RCC_EXTI_CLK_SOURCE_LSCLK;
    (void)FL_EXTI_CommonInit(&extiCommonInitStruct);
    
    extiInitStruct.input    = FL_GPIO_EXTI_INPUT_GROUP3;            /* PB11ⲿжϹ */
    extiInitStruct.filter      = FL_ENABLE;                         /* ʹ˲ */
    extiInitStruct.triggerEdge = FL_GPIO_EXTI_TRIGGER_EDGE_RISING;  /* ô */
    (void)FL_EXTI_Init(FL_GPIO_EXTI_LINE_6, &extiInitStruct);

    /* жϱʶ */
    FL_GPIO_ClearFlag_EXTI(GPIO, FL_GPIO_EXTI_LINE_6);

    NVIC_DisableIRQ(GPIO_IRQn);
    NVIC_SetPriority(GPIO_IRQn, GPIO_IRQ_PRI); 
    NVIC_EnableIRQ(GPIO_IRQn);
}



/**
  * @brief  Key Ѻʼ
  * @param  0-ͨ 1-ΪλѵԴ
  * @retval void
  */
void KEY_Awake_Init(uint8_t awake_type)
{
    /* 򿪷ǻIO */
    
    /* ʼ */

    /* Դ */
    /* رж */
    FL_GPIO_SetTriggerEdge(GPIO, FL_GPIO_EXTI_LINE_6, FL_GPIO_EXTI_TRIGGER_EDGE_RISING);
    Close_And_ClearIRQ(GPIO_IRQn);
    
    /* ǻ账 */
}

/**
  * @brief  Key Sleepж
  * @param  void
  * @retval 1: Sleep
  *         0: Wake
  */
uint8_t KEY_IS_Sleep(void)
{
    if (1)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}


#endif

