/**    
  ******************************************************************************
  * @attention    
  * Copyright 2023 SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICRO.)
  *        
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met: 
  *    
  * 1. Redistributions of source code must retain the above copyright notice, 
  *    this list of conditions and the following disclaimer.
  *    
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  *    
  * 3. Neither the name of the copyright holder nor the names of its contributors 
  *    may be used to endorse or promote products derived from this software without
  *    specific prior written permission.
  *    
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
  * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
  * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
  *******************************************************************************
  */
#include   "led.h"
#include   "mf_config.h"


#if LED_TOG_MODE


/**
  * @brief  LED ųʼ
  * @param  void
  * @retval void
  */
void LED_Iint(void)
{
    FL_GPIO_InitTypeDef GPIO_InitStruct = { 0 };
    
    /* λĴд1LEDʼʱ˸ */
    FL_GPIO_SetOutputPin(LED1_GPIO, LED1_PIN);
    FL_GPIO_SetOutputPin(LED2_GPIO, LED2_PIN);
    FL_GPIO_SetOutputPin(LED3_GPIO, LED3_PIN); 
    
    /* GPIO ܳʼ */
    GPIO_InitStruct.pin = LED1_PIN|LED2_PIN|LED3_PIN;
    GPIO_InitStruct.mode = FL_GPIO_MODE_OUTPUT;
    GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
    GPIO_InitStruct.pull = FL_DISABLE;
    (void)FL_GPIO_Init(LED1_GPIO, &GPIO_InitStruct);
    (void)FL_GPIO_Init(LED3_GPIO, &GPIO_InitStruct);
    
}


/**
  * @brief  ָʾ
  * @note   ̵˸
  * @param  void
  * @retval void
  */
void LED_AWAKE_TEST(void)
{
    LED1_OFF();
    LED2_OFF();
    LED3_TOG();
    FL_DelayMs(100);
    LED3_TOG();
    FL_DelayMs(100);
    LED3_TOG();
    FL_DelayMs(100);
    LED3_TOG();
    FL_DelayMs(100);
    LED3_TOG();
    FL_DelayMs(100);
    LED3_TOG();
}


/**
  * @brief  ָʾ
  * @note   ˸
  * @param  void
  * @retval void
  */
void LED_KEY_TEST(void)
{
    LED2_OFF();
    LED3_OFF();
    LED1_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    FL_DelayMs(100);
    LED1_TOG();
}


/**
  * @brief  ָʾ
  * @note   ˸
  * @param  void
  * @retval void
  */
void LED_ENTER_SLEEP_TEST(void)
{
    LED1_OFF();
    LED3_OFF();
    LED2_TOG();
    FL_DelayMs(100);
    LED2_TOG();
    FL_DelayMs(100);
    LED2_TOG();
    FL_DelayMs(100);
    LED2_TOG();
    FL_DelayMs(100);
    LED2_TOG();
    FL_DelayMs(100);
    LED2_TOG();
}


/**
  * @brief  ϵͳָʾ
  * @note   ׵˸
  * @param  void
  * @retval void
  */
void LED_RUN_TEST(void)
{
    LED1_ON();
    LED3_ON();
    LED2_ON();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_TOG();
}


/**
  * @brief  IICָܵʾ
  * @note   ۵˸
  * @param  void
  * @retval void
  */
void LED_IIC_TEST(void)
{
    LED1_TOG();
    LED2_TOG();
    LED3_OFF();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_OFF();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_OFF();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_OFF();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_OFF();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_OFF();
    LED2_TOG();
}


/**
  * @brief  SPIָܵʾ
  * @note   ˸
  * @param  void
  * @retval void
  */
void LED_SPI_TEST(void)
{
    LED1_TOG();
    LED3_TOG();
    LED2_OFF();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_OFF();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_OFF();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_OFF();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_OFF();
    FL_DelayMs(100);
    LED1_TOG();
    LED3_TOG();
    LED2_OFF();
}


/**
  * @brief  USER_FLASHָܵʾ
  * @note   Ƶ˸
  * @param  void
  * @retval void
  */
void LED_USER_FLASH_TEST(void)
{
    LED1_OFF();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_OFF();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_OFF();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_OFF();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_OFF();
    LED3_TOG();
    LED2_TOG();
    FL_DelayMs(100);
    LED1_OFF();
    LED3_TOG();
    LED2_TOG();
}


/**
  * @brief  LEDʾ
  * @note   ˸
  * @param  void
  * @retval void
  */
void LED_TEST_TEST(void)
{
    LED1_OFF();
    LED3_ON();
    LED2_ON();
    FL_DelayMs(100);
    LED1_ON();
    LED3_ON();
    LED2_OFF();
    FL_DelayMs(100);
    LED1_ON();
    LED3_OFF();
    LED2_ON();
    FL_DelayMs(100);
    LED1_ON();
    LED2_OFF();
    LED3_OFF();
    FL_DelayMs(100);
    LED1_OFF();
    LED2_ON();
    LED3_OFF();
    FL_DelayMs(100);
    LED1_OFF();
    LED3_ON();
    LED2_OFF();
}

#if (SLEEP_SUPPORT == 1)

/**
  * @brief  LED ǰʼ
  * @param  void
  * @retval void
  */
void LED_Sleep_Init(void)
{
    CloseIO(GPIOC, FL_GPIO_PIN_0);
    CloseIO(GPIOC, FL_GPIO_PIN_1);
    CloseIO(GPIOA, FL_GPIO_PIN_4);
}


/**
  * @brief  LED Ѻʼ
  * @param  0-ͨ 1-ΪλѵԴ
  * @retval void
  */
void LED_Awake_Init(uint8_t awake_type)
{
    OutputIO(GPIOC, FL_GPIO_PIN_0, FL_GPIO_OUTPUT_PUSHPULL);
    OutputIO(GPIOC, FL_GPIO_PIN_1, FL_GPIO_OUTPUT_PUSHPULL);
    OutputIO(GPIOA, FL_GPIO_PIN_4, FL_GPIO_OUTPUT_PUSHPULL);
}


/**
  * @brief  LED sleepж
  * @param  void
  * @retval 1: Sleep
  *         0: Wake
  */
uint8_t LED_IS_Sleep(void)
{
    if (1)/* ʱɽsleep */
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

#endif


#endif

