/*
 * Copyright (c) 2022, SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICROELECTRONICS./ FUDAN MICRO.)
 * All rights reserved.
 *
 * Processor:                   FM33LE0xxA
 * http:                        http://www.fmdevelopers.com.cn/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * 4. To provide the most up-to-date information, the revision of our documents 
 *    on the World Wide Web will be the most Current. Your printed copy may be  
 *    an earlier revision. To verify you have the latest information avaliable,
 *    refer to: http://www.fmdevelopers.com.cn/.
 *
 * THIS SOFTWARE IS PROVIDED BY FUDAN MICRO "AS IS" AND ANY EXPRESSED 
   ORIMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
   OF MERCHANTABILITY NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED.IN NO EVENT SHALL FUDAN MICRO OR ITS CONTRIBUTORS BE LIABLE 
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISINGIN ANY WAY OUT OF THE 
   USE OF THIS SOFTWARE, EVEN IF ADVISED OFTHE POSSIBILITY OF SUCH DAMAGE.
*/
#include "main.h"
#include "lpuart.h"



/********************************* LPUART жϷ *********************************/
/**
  * @brief  LPUART0жϺ
  * @param  void
  * @retval void
  */
void LPUART0_IRQHandler(void)
{
    uint8_t tmp08;

    /* жϴ */
    if((FL_ENABLE == FL_LPUART_IsEnabledIT_RXBuffFull(LPUART0))
            && (FL_SET == FL_LPUART_IsActiveFlag_RXBuffFull(LPUART0)))
    {
        /* жתյ */
        tmp08 = FL_LPUART_ReadRXBuff(LPUART0); /* жϱ־ͨȡrxregĴ */
        FL_LPUART_WriteTXBuff(LPUART0, tmp08);
    }

    /* жϴ */
    if((FL_ENABLE == FL_LPUART_IsEnabledIT_TXShiftBuffEmpty(LPUART0))
            && (FL_SET == FL_LPUART_IsActiveFlag_TXShiftBuffEmpty(LPUART0)))
    {
        /* жϱ־ͨдtxregĴtxifд1 */
        
        /* жϷһֽݣ0x02 */
        FL_LPUART_WriteTXBuff(LPUART0, 0x02);             /* һֽ */
        FL_LPUART_ClearFlag_TXShiftBuffEmpty(LPUART0);    /* жϱ־ */
        FL_LPUART_DisableIT_TXShiftBuffEmpty(LPUART0);
    }
}



/********************************* LPUART ģʼ *********************************/
/**
  * @brief  LPUARTʼ
  * @param  void
  * @retval void
  */
void LPUART_Init(LPUART_Type *LPUARTx , uint8_t IsEnableIRQ)
{
    FL_LPUART_InitTypeDef  initStructer = {0};
    FL_GPIO_InitTypeDef  GPIO_InitStruct = {0};

    switch ((uint32_t)LPUARTx) 
    {
        case LPUART0_BASE:
            GPIO_InitStruct.pin = FL_GPIO_PIN_13;
            GPIO_InitStruct.mode = FL_GPIO_MODE_DIGITAL;              /* ֹ */
            GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;     /*  */
            GPIO_InitStruct.pull = FL_ENABLE;                         /* ʹ */
            GPIO_InitStruct.remapPin = FL_ENABLE;                     /* ʹֹܶ */
            FL_GPIO_Init(GPIOA,&GPIO_InitStruct);                     /* PA13 */

            GPIO_InitStruct.pin = FL_GPIO_PIN_14;
            GPIO_InitStruct.mode = FL_GPIO_MODE_DIGITAL;              /* ֹ */
            GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;     /*  */
            GPIO_InitStruct.pull = FL_DISABLE;                        /* Ͳ */
            GPIO_InitStruct.remapPin = FL_ENABLE;                     /* ʹֹܶ */
            FL_GPIO_Init(GPIOA,&GPIO_InitStruct);                     /* PA14 */
            
            #if IsEnableIRQ
            NVIC_DisableIRQ(LPUART0_IRQn);
            NVIC_SetPriority(LPUART0_IRQn,2);
            NVIC_EnableIRQ(LPUART0_IRQn);
            #endif
        break;
        
        case LPUART1_BASE:
            GPIO_InitStruct.pin = FL_GPIO_PIN_2;
            GPIO_InitStruct.mode = FL_GPIO_MODE_DIGITAL;                /* ֹ */
            GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;       /*  */
            GPIO_InitStruct.pull = FL_ENABLE;                           /* ʹ */
            GPIO_InitStruct.remapPin = FL_ENABLE;                       /* ʹֹܶ */
            FL_GPIO_Init(GPIOC, &GPIO_InitStruct);                      /* PC2 */

            GPIO_InitStruct.pin = FL_GPIO_PIN_3;
            GPIO_InitStruct.mode = FL_GPIO_MODE_DIGITAL;                /* ֹ */
            GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;       /*  */
            GPIO_InitStruct.pull = FL_DISABLE;                          /* Ͳ */
            GPIO_InitStruct.remapPin = FL_ENABLE;                       /* ʹֹܶ */
            FL_GPIO_Init(GPIOC, &GPIO_InitStruct);                      /* PC3 */
            
            #if IsEnableIRQ
            NVIC_DisableIRQ(LPUART1_IRQn);
            NVIC_SetPriority(LPUART1_IRQn,2);
            NVIC_EnableIRQ(LPUART1_IRQn);
            #endif
        break;
        
        default:
            break;
    }

    initStructer.clockSrc             = FL_RCC_LPUART_CLK_SOURCE_LSCLK;  /* ʱԴLSCLK */
    initStructer.baudRate             = FL_LPUART_BAUDRATE_9600;          /* 9600 */
    initStructer.dataWidth            = FL_LPUART_DATA_WIDTH_8B;          /* 8λλ */
    initStructer.stopBits             = FL_LPUART_STOP_BIT_WIDTH_1B;      /* 1λֹͣλ */
    initStructer.parity               = FL_LPUART_PARITY_EVEN ;           /* żУ */
    initStructer.transferDirection    = FL_LPUART_DIRECTION_TX_RX;        /* ʹܷͺͽ */
    FL_LPUART_Init(LPUARTx, &initStructer);
    
}



/**
  * @brief  LPUARTѯ
  * @param  void
  * @retval void
  */
void LPUART_Test(LPUART_Type *LPUARTx)
{
    uint8_t testTxData[12] = {0x55, 0x5A, 0x53};
    uint8_t i;
    
    LPUART_Init(LPUARTx , FL_DISABLE );

    for(i = 0; i < 3; i++)
    {
        FL_LPUART_WriteTXBuff(LPUARTx, testTxData[i]);                      /* д뷢ͼĴ */

        while(FL_LPUART_IsActiveFlag_TXShiftBuffEmpty(LPUARTx) == 0);       /* ȴλշ */

        FL_LPUART_ClearFlag_TXShiftBuffEmpty(LPUARTx);
    }

}



/**
  * @brief  LPUARTжϲ
  * @param  LPUARTx: ѡ
  * @retval void
  */
void Test_LPUartx(LPUART_Type *LPUARTx)
{
    uint8_t TestTxData[1] ={0x01};

    LPUART_Init(LPUARTx , FL_ENABLE );

    FL_LPUART_ClearFlag_TXShiftBuffEmpty(LPUARTx);
    FL_LPUART_EnableIT_TXShiftBuffEmpty(LPUARTx);
    
    /*ϵ緢һֽݣ0x01*/
    FL_LPUART_WriteTXBuff(LPUARTx, TestTxData[0]);
    
    FL_LPUART_EnableIT_RXBuffFull(LPUARTx);
}



/********************************* LPUART ģ鸴λ *********************************/
/**
  * @brief  LPUART0ģ鸴λ
  * @param  void
  * @retval void
  */
void LPUART0_DeInit(void)
{
    /* ָĴλֵ */
    FL_LPUART_DeInit(LPUART0);

    /* жϹ */
    NVIC_ClearPendingIRQ(LPUART0_IRQn);
    
    /* رж */
    NVIC_DisableIRQ(LPUART0_IRQn);
}



/**
  * @brief  LPUART1ģ鸴λ
  * @param  void
  * @retval void
  */
void LPUART1_DeInit(void)
{
    /* ָĴλֵ */
    FL_LPUART_DeInit(LPUART1);

    /* жϹ */
    NVIC_ClearPendingIRQ(LPUART1_IRQn);
    
    /* رж */
    NVIC_DisableIRQ(LPUART1_IRQn);
}




